    append([], L, L).
    append([X|L1], L2, [X|L3]) :-
        append(L1, L2, L3).

    ordered([]).
    ordered([X]) :- number(X).
    ordered([X,Y|Ys]) :-
        X =< Y,
        ordered([Y|Ys]).

    icsort(Xs, Ys) :-
            append(As, [X,Y|Bs], Xs),
            X > Y,
            append(As, [Y,X|Bs], Xs1),
            icsort(Xs1, Ys).
    icsort(Xs, Xs) :-
            ordered(Xs).

:- type nat ::= 0 ; s(nat).
%:- type list(A) ::= [] ; [A|list(A)].




