/*			       
	psort(Xs,Ys) :- 
		The list Ys is an ordered permutation of the list Xs.
*/
	
	psort(Xs,Ys) :- permutation(Xs,Ys), ordered(Ys).

	permutation(Xs,[Z|Zs]) :- select(Z,Xs,Ys), permutation(Ys,Zs).
	permutation([],[]).

	ordered([]).
	ordered([X]) :- number(X).
	ordered([X,Y|Ys]) :- X =< Y, ordered([Y|Ys]).

	select(X,[X|Xs],Xs).
	select(X,[Y|Ys],[Y|Zs]) :- select(X,Ys,Zs).

%	Program 3.20 Permutation sort

:- type nat ::= 0 ; s(nat).
%:- type list(A) ::= [] ; [A|list(A)].



