/*
   connected(X,Y) :-
	Node X is connected to node Y in the graph defined by edge/2.
*/	

     connected(X,Y) :- connected(X,Y,[X]).

     connected(X,X,Visited).
     connected(X,Y,Visited) :- 
		edge(X,N), \+ member(N,Visited), connected(N,Y,[N|Visited]).

	member(X,[X|L]).
	member(X,[Y|L]) :- member(X,L).


  /*  Data   */

     edge(a,b).   

%	Program 14.10: Connectivity in a graph


%:- type list(A) ::= [] ; [A|list(A)].
:- type point ::= a;b;c;d;e;f;g;h;i;j;k;u;v;x;y;z.


