
%%%%%%%%%%%%%%%%%%% ex_asem_path_data

flight(shanghai,beijin).
flight(shanghai,tokyo).
flight(tokyo,hongkong).
flight(tokyo,london).
flight(beijin, london).
flight(hongkong, london). 

link(X,Y,P) :- 
    link(X,Y,[X],P).

link(X,Y,P0,[Y|P0]) :-
    flight(X,Y).
link(X,Y,P0,[Y|P0]) :-
    flight(Y,X).
link(X,Y,P0,P) :-
    flight(X,Z),
    \+ member(Z,P0),
    link(Z,Y,[Z|P0],P).
link(X,Y,P0,P) :-
    flight(Z,X), 
    \+ member(Z,P0),
    link(Z,Y,[Z|P0],P).

member(X,[X|_]).
member(X,[_|L]) :-
    member(X,L).

