qs([X|L],L0) :-
    part(L,X,L1,L2),
    qs(L1,L3),
    qs(L2,L4),
    ap([X|L3],L4,L0). % ap(L3,[X|L4],L0)
qs([],[]).

part([X|L],Y,L1,[X|L2]):- 
                       % leq(Y,X),
    part(L,Y,L1,L2).
part([X|L],Y,[X|L1], L2) :-
    leq(Y,X),          % gt(Y,X)
    part(L,Y,L1,L2).
part([],X,[],[]).

ap([X|L1],L2,[X|L3]) :-
     ap(L1,L2,L2). %ap(L1,L2,L3).
ap([],L,[]).       %ap([],L,L).


leq(0,0).
leq(0,s(X))    :- 
	leq(0,X).
leq(s(X),s(Y)) :- 
	leq(X,Y).

gt(s(0),0).
gt(s(X),0)	:-
	gt(X,0).
gt(s(X),s(Y)) :-
	gt(X,Y).


:- type nat ::= 0 ; s(nat).
%:- type list(A) ::= [] ; [A|list(A)].




