
partition([X|T],P,[X|B],A) :-
    X =< P,
    partition(T,P,B,A).

partition([X|T],P,B,[X|A]) :-
    X > P,
    partition(T,P,B,A).

partition([],_,[],[]).


qsort([X|T],S) :-
     partition(T,X,B,A),
     qsort(A,S1),
     qsort(B,S2),
     append(S1,[X|S2],S). %add X in between
qsort([],[]).

append([],L,L).
append([X|L1],L2,[X|L3]) :-
    append(L1,L2,L3).



